// Chaoskart Exists!
rawset(_G, "ChaosKartREAL", {})

// On or Off?
rawset(_G, "cv_chaoskart", CV_RegisterVar({
  name = "chaoskart",
  defaultvalue = "On",
  flags = CV_NETVAR,
  PossibleValue = {Off = 0, On = 1},
}))

// Eventtimer
rawset(_G, "cv_starteventtime", CV_RegisterVar({
  name = "ck_eventtime",
  defaultvalue = 20,
  flags = CV_NETVAR,
  PossibleValue = {MIN = 1, MAX = 300},
}))

// Some variables
rawset(_G, "chaosmod", {
	// Timers
	eventtimer = cv_starteventtime.value,
	eventdisplay = 0,
	eventcooldown = 0,
	
	// Perm Effects
	permeffect = nil,
	permeffectdesc = nil,
	
	// Playercount
	playercount = 0,
	
	// Event variables
	wind = 0,
	windangle = 0,
	springtimer = 0,
	itemrain = 0,
	rockrain = 0,
	tacorain = 0,
	bananarain = 0,
	badnikrain = 0,
	jumpdrift = 0,
	firstpick = true,
	icyfloor = 0,
	deathevent1 = nil,
	deathevent2 = nil,
	maxspark = 0,
	alwaysdrift = 0,
	alwaysitem = 0,
	hotpotato = 0,
	originalholder = nil,
	alwaysdrift = 0,
	invis = 0,
	lightsoff = 0,
	bumpfuck = 0,
	dorifto = 0,
	autoaccel = 0,
	controlinvert = 0,
	heavygravity = 0,
	lowgravity = 0,
	bouncy = 0,
	deathroulette = false,
	deathrouletteprepare = 0,
	deathcooldown = 0,
	nextevent = nil,
	backwards = 0,
	upspeed = 0,
	downspeed = 0,
	unseenitem = 0,
	nospark = 0,
	hail = 0,
	nighttime = false,
	sunlight = false,
	firerain = 0,
	permajumpdrift = 0,
--	crumbl = -1,
--	savecrumbl = {},
})

// Regular Events
rawset(_G, "ckEvents", {})

// Battle Events
rawset(_G, "ckBattleEvents", {})

// Rare Events
rawset(_G, "ckRareEvents", {})

// Battle Rare Events
rawset(_G, "ckBattleRareEvents", {})

// Regular Perm Effects
rawset(_G, "ckPermEffects", {})

// Battle Perm Effects
rawset(_G, "ckBattlePermEffects", {})

// Rare Perm Effects
rawset(_G, "ckRarePermEffects", {})

// Battle Rare Perm Effects
rawset(_G, "ckBattleRarePermEffects", {})

// Custom Items
rawset(_G, "ckItems", {})

// Sprite Freeslots
freeslot("SPR_HPTO")

// Initiate Certain Variables
rawset(_G, "ckResetVars", function()
	for p in players.iterate 
		p.hashotpotato = false
		p.nodrift = false
	end
	chaosmod.wind = 0
	chaosmod.windangle = 0
	chaosmod.springtimer = 0
	chaosmod.itemrain = 0
	chaosmod.rockrain = 0
	chaosmod.tacorain = 0
	chaosmod.bananarain = 0
	chaosmod.badnikrain = 0
	chaosmod.jumpdrift = 0
	chaosmod.firstpick = true
	chaosmod.icyfloor = 0
	chaosmod.deathevent1 = nil
	chaosmod.deathevent2 = nil
	chaosmod.maxspark = 0
	chaosmod.alwaysdrift = 0
	chaosmod.alwaysitem = 0
	chaosmod.hotpotato = 0
	chaosmod.originalholder = nil
	chaosmod.alwaysdrift = 0
	chaosmod.invis = 0
	chaosmod.lightsoff = 0
	chaosmod.bumpfuck = 0
	chaosmod.dorifto = 0
	chaosmod.autoaccel = 0
	chaosmod.controlinvert = 0
	chaosmod.heavygravity = 0
	chaosmod.lowgravity = 0
	chaosmod.bouncy = 0
	chaosmod.deathroulette = false
	chaosmod.deathrouletteprepare = 0
	chaosmod.deathcooldown = 0
	chaosmod.nextevent = nil
	chaosmod.backwards = 0
	chaosmod.upspeed = 0
	chaosmod.downspeed = 0
	chaosmod.unseenitem = 0
	chaosmod.nospark = 0
	chaosmod.hail = 0
	chaosmod.permeffect = nil
	chaosmod.permeffectdesc = nil
	chaosmod.nighttime = false
	chaosmod.sunlight = false
	chaosmod.firerain = 0
	chaosmod.randscale = 0
--	chaosmod.crumbl = -1
--	chaosmod.savecrumbl = {}
	
	if leveltime > 7*TICRATE
		chaosmod.eventtimer = cv_starteventtime.value - G_TicsToSeconds(leveltime)
	else
		chaosmod.eventtimer = cv_starteventtime.value
	end
	chaosmod.eventdisplay = 0
	chaosmod.eventcooldown = 0
end)

ckResetVars()

addHook("MapLoad", function()
	ckResetVars()
end)

// Smooth Transition to Death Roulette
rawset(_G, "hudy", 0)

// Random Checks
rawset(_G, "ckEventChance", function()
	local num = P_RandomRange(1, 100)
	return num
end)

// Things bounce off of walls.
rawset(_G, "ckWallCheck", function(mobj)
	if mobj and mobj.valid
		local r = mobj.radius
		local wall = R_PointInSubsector(mobj.x + FixedMul(2*r, cos(mobj.angle)), mobj.y + FixedMul(2*r, sin(mobj.angle))).sector
		local trymove = R_PointToAngle2(mobj.x, mobj.y, mobj.x + 5*FRACUNIT, mobj.y + 5*FRACUNIT)
		if not P_TryMove(mobj, mobj.x + (cos(trymove) / 6), mobj.y + (cos(trymove) / 6)) and (mobj.valid)
			mobj.angle = $1 + (R_PointToAngle2(mobj.x, mobj.y, mobj.x + FixedMul(2*r, cos(mobj.angle)), mobj.y + FixedMul(2*r, sin(mobj.angle)))*-1)
			return true
		end
		return false
	end
end)