--------------------
-- Regular Events --
--------------------

-- Handy for some events
local chk = chaosmod

-- Blows up first place.
ckAddEvent(ckEvents, {
	name = "Explode 1st",
	shortname = "ExplodeFirst",
	eventprint = "1st place was blown up!",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == 1 and p and p.mo
				K_SpawnMineExplosion(p.mo, p.mo.color)
				p.kartstuff[k_spinouttimer] = 3*TICRATE
				P_StartQuake(30*FRACUNIT, TICRATE/2)
				P_InstaThrust(p.mo, p.mo.angle, 0)
				P_SetObjectMomZ(p.mo, 10*FRACUNIT)
			end
		end
	end,
})

-- Blows up everyone.
ckAddEvent(ckEvents, {
	name = "Explode All",
	shortname = "Explosion",
	eventprint = "You were blown up!",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				K_SpawnMineExplosion(p.mo, p.mo.color)
				p.kartstuff[k_spinouttimer] = 3*TICRATE
				P_StartQuake(30*FRACUNIT, TICRATE/2)
				P_InstaThrust(p.mo, p.mo.angle, 0)
				P_SetObjectMomZ(p.mo, 10*FRACUNIT)
			end
		end
	end,
})

-- Last place gets invincibility.
ckAddEvent(ckEvents, {
	name = "Invincibility",
	shortname = "InvincLast",
	eventprint = "Last place was given invincibility!",
	namecol = SKINCOLOR_YELLOW,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == chk.playercount and p and p.mo
				p.kartstuff[k_invincibilitytimer] = 15*TICRATE
			end
		end
	end,
})

-- First place cannot drift.
ckAddEvent(ckEvents, {
	name = "Driftless",
	shortname = "DriftlessFirst",
	eventprint = "1st Place can't seem to drift anymore!",
	namecol = SKINCOLOR_BROWN,
	battlemode = false,
	eventthink = function()
		for p in players.iterate
			p.nodrift = $ or 0

			if p.nodrift >= 1
				p.kartstuff[k_drift] = 0
				p.nodrift = $ - 1
				if p.playerstate == PST_DEAD
					p.nodrift = 0
				end
			end
		end
	end,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == 1 and p and p.mo
				if time == nil
					p.nodrift = 10*TICRATE
				else
					p.nodrift = time*TICRATE
				end
			end
		end
	end,
})

-- Everyone cannot drift
ckAddEvent(ckEvents, {
	name = "Driftless",
	shortname = "DriftlessAll",
	eventprint = "You can't seem to drift anymore!",
	namecol = SKINCOLOR_BROWN,
	candeathroulette = true,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				if time == nil
					p.nodrift = 10*TICRATE
				else
					p.nodrift = time*TICRATE
				end
			end
		end
	end,
})

-- Last place gets an spb
ckAddEvent(ckEvents, {
	name = "SPB",
	shortname = "SPBLast",
	eventprint = "Last place got an SPB!",
	namecol = SKINCOLOR_RED,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == chk.playercount and p and p.mo
				p.kartstuff[k_itemtype] = 10
				p.kartstuff[k_itemamount] = 1
			end	
		end
	end,
})

-- Last Place is Grown
ckAddEvent(ckEvents, {
	name = "Growth",
	shortname = "GrowLast",
	eventprint = "Last Place is Grown!",
	namecol = SKINCOLOR_BLUE,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == chk.playercount and p and p.mo
				p.mo.destscale = p.mo.scale*2
				p.kartstuff[k_growshrinktimer] = 15*TICRATE
			end
		end
	end,
})

-- 1st Place is Shrunk
ckAddEvent(ckEvents, {
	name = "Shrink",
	shortname = "ShrinkFirst",
	eventprint = "1st Place is Shrunk!",
	namecol = SKINCOLOR_ORANGE,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == 1 and p and p.mo
				p.mo.destscale = p.mo.scale/2
				p.kartstuff[k_growshrinktimer] = -15*TICRATE
			end
		end
	end,
})

-- Everyone is shrunk
ckAddEvent(ckEvents, {
	name = "Shrink All",
	shortname = "ShrinkAll",
	eventprint = "Everyone is shrunk!",
	namecol = SKINCOLOR_ORANGE,
	candeathroulette = true,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				p.mo.destscale = p.mo.scale/2
				if time == nil
					p.kartstuff[k_growshrinktimer] = (-15 - p.kartstuff[k_position])*TICRATE
				else
					p.kartstuff[k_growshrinktimer] = -time*TICRATE
				end
			end
		end
	end,
})

-- A Random Player is turned around
ckAddEvent(ckEvents, {
	name = "Turn Around",
	shortname = "FlipRand",
	eventprint = "A Random Player was turned around!",
	namecol = SKINCOLOR_GREEN,
	eventfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
		if pl.mo
			pl.mo.angle = $ + ANGLE_180
		end
	end,
})

-- Everyone is turned around
ckAddEvent(ckEvents, {
	name = "Turn Around",
	shortname = "FlipAll",
	eventprint = "You were turned around!",
	namecol = SKINCOLOR_GREEN,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo then p.mo.angle = $ + ANGLE_180 end
		end
	end,
})

-- A Random Player is spun out
ckAddEvent(ckEvents, {
	name = "Spin Out",
	shortname = "SpinRand",
	eventprint = "A Random Player was spun around!",
	namecol = SKINCOLOR_RED,
	eventfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local angle = P_RandomRange(0, 360)*FRACUNIT
		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
		if pl.mo
			pl.kartstuff[k_spinouttimer] = 5*TICRATE
			P_InstaThrust(pl.mo, angle, P_RandomRange(4, 10)*FRACUNIT)
		end
	end,
})

-- Everyone is speedy!
ckAddEvent(ckEvents, {
	name = "Speed Shoes",
	shortname = "Speed",
	eventprint = "Everyone suddenly sped up!",
	namecol = SKINCOLOR_RED,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				K_DoSneaker(p)
				p.kartstuff[k_sneakertimer] = 5*TICRATE
			end
		end
	end,
})

-- A random player gets 5 orbinauts
ckAddEvent(ckEvents, {
	name = "Orbinauts",
	shortname = "OrbinautsRand",
	eventprint = "A random player was given 5 Orbinauts!",
	namecol = SKINCOLOR_GRAY,
	eventfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
		pl.kartstuff[k_itemtype] = KITEM_ORBINAUT
		pl.kartstuff[k_itemamount] = 5
	end,
})

-- Randomise Speed and Weight
ckAddEvent(ckEvents, {
	name = "Random Stats",
	shortname = "RandStats",
	eventprint = "Your speed and weight were randomised!",
	namecol = SKINCOLOR_GRAY,
	eventfunc = function(time)
		for p in players.iterate
			p.kartspeed = P_RandomRange(1, 9)
			p.kartweight = P_RandomRange(1, 9)
		end
	end,
})

-- Windy
ckAddEvent(ckEvents, {
	name = "Windy",
	shortname = "Windy",
	eventprint = "It got really windy all of a sudden!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Windy", "wind"},
	eventthink = function()
		if chk.wind >= 1
			for p in players.iterate
				if p and p.mo
					p.mo.momx = $ - cos(chk.windangle) / 4
					p.mo.momy = $ - sin(chk.windangle) / 4
				end
			end
			chk.wind = $ - 1
		end
	end,
	eventfunc = function(time)
		chk.windangle = P_RandomRange(0, 360)*ANG1
		if time == nil
			chk.wind = 10*TICRATE
		else
			chk.wind = time*TICRATE
		end
	end,
})

-- Everyone loses item
ckAddEvent(ckEvents, {
	name = "Lose Item",
	shortname = "LoseItem",
	eventprint = "You lost your item!",
	namecol = SKINCOLOR_RED,
	eventfunc = function(time)
		for p in players.iterate
			p.kartstuff[k_itemtype] = 0
			p.kartstuff[k_itemamount] = 0
		end
	end,
})

-- Jumpdrift
ckAddEvent(ckEvents, {
	name = "Jumpdrift",
	shortname = "Jumpdrift",
	eventprint = "Your kart starts feeling bouncy...",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	battlemode = false,
	var = {"Jumpdrift", "jumpdrift"},
	eventthink = function()
		if chk.jumpdrift >= 1
			for p in players.iterate
				if p.mo and p
					p.driftjumped = $ or false
					
					if (p.cmd.buttons & BT_DRIFT)
						if p.driftjumped == false and P_IsObjectOnGround(p.mo)
							S_StartSound(p.mo, sfx_s3k56)
							if (p.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(p.mo, 2*FRACUNIT)
							else
								P_SetObjectMomZ(p.mo, 5*FRACUNIT)
							end
							p.driftjumped = true
						end
					end

					if P_IsObjectOnGround(p.mo) and not (p.cmd.buttons & BT_DRIFT)
						p.frameangle = p.mo.angle
						p.driftjumped = false
					end
				end
			end
			chk.jumpdrift = $ - 1
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.jumpdrift = 20*TICRATE
		else
			chk.jumpdrift = time*TICRATE
		end
	end,
})

-- Everyone is spun out
ckAddEvent(ckEvents, {
	name = "Spin All Out",
	shortname = "SpinAll",
	eventprint = "You were spun around!",
	namecol = SKINCOLOR_RED,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				local angle = P_RandomRange(0, 360)*FRACUNIT
				p.kartstuff[k_spinouttimer] = 3*TICRATE
				P_InstaThrust(p.mo, angle, P_RandomRange(4, 10)*FRACUNIT)
			end
		end
	end,
})

-- First Place is spun out
ckAddEvent(ckEvents, {
	name = "Spin Out",
	shortname = "Spin1st",
	eventprint = "First was spun around!",
	namecol = SKINCOLOR_GOLD,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			local angle = P_RandomRange(0, 360)*FRACUNIT
			if (p.kartstuff[k_position] == 1) and (p and p.mo)
				p.kartstuff[k_spinouttimer] = 5*TICRATE
				P_InstaThrust(p.mo, angle, P_RandomRange(4, 10)*FRACUNIT)
			end
		end
	end,
})

-- Everyone is thrusted backwards.
ckAddEvent(ckEvents, {
	name = "Thrusted Backwards",
	shortname = "ThrustBack",
	eventprint = "You were thrusted backwards!",
	namecol = SKINCOLOR_POPCORN,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				P_InstaThrust(p.mo, p.mo.angle, -30*FRACUNIT)
			end
		end
	end,
})

-- Hot Potato
ckAddEvent(ckEvents, {
	name = "Hot Potato",
	shortname = "HotPotato",
	namecol = SKINCOLOR_CINNAMON,
	cooldown = 10,
	var = {"Hot-Potato", "hotpotato"},
	eventthink = function()
		if chk.hotpotato >= 0
			chk.hotpotato = $1 - 1
		end

		-- Meat of the code, here we go!
		for p in players.iterate

			p.justbump = $ or false

			-- Bump Check		
			if p.justbump == true and not (leveltime%35)
				p.justbump = false
			end

			if p and p.mo and p.valid and p.mo.valid
				if p.hashotpotato == true and chk.hotpotato >= 1
					p.kartstuff[k_driftboost] = 42 --I had to
					local smoke = P_SpawnMobj(p.mo.x+P_RandomRange(-25, 25)*p.mo.scale, p.mo.y+P_RandomRange(-25, 25)*p.mo.scale, p.mo.z+P_RandomRange(5, 30)*p.mo.scale, MT_SMOKE)
					P_SetObjectMomZ(smoke, P_RandomRange(1, 3)*p.mo.scale)
					if chk.hotpotato <= 5*TICRATE
						if not S_SoundPlaying(p.mo, sfx_kc51) then S_StartSound(p.mo, sfx_kc51) end
					end
					local icon = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + P_GetPlayerHeight(p), MT_THOK)
					icon.sprite = SPR_HPTO
					icon.frame = FF_FULLBRIGHT|A
					icon.tics = 1
					if chk.hotpotato <= 6*TICRATE and not (leveltime%5)
						icon.frame = B
					end
				end
			end
			
			if p.hashotpotato == true and chk.hotpotato <= 0
				print(p.name.." had the hot potato when it exploded!")
				P_DamageMobj(p.mo, chk.originalholder.mo, chk.originalholder.mo)
				K_SpawnMineExplosion(p.mo, chk.originalholder.mo.color)
				p.justbump = false
				p.hashotpotato = false
				if gametype == GT_BATTLE
					p.kartstuff[k_bumper] = $1 - 1
					P_AddPlayerScore(chk.originalholder.mo.player, 1)
				end
				p.kartstuff[k_spinouttimer] = $1 + 5*TICRATE
				P_StartQuake(30*FRACUNIT, TICRATE/2)
				P_SetObjectMomZ(p.mo, 50*FRACUNIT)
				chk.originalholder = nil
			end
		end
	end,
	eventfunc = function(time)
		if chk.hotpotato >= 1
			print("There is a Hot Potato present already!")
		else
			chk.hotpotato = 20*TICRATE
			local possibleplayers = {}
			for p in players.iterate
				if p and p.mo then table.insert(possibleplayers, p) end
			end

			local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
			chk.originalholder = pl
			print(pl.name.." got the hot potato! Avoid getting tagged at all costs!")
		end
	end,
})

-- Everyone is thrusted upwards.
ckAddEvent(ckEvents, {
	name = "Thrusted Upwards",
	shortname = "ThrustUp",
	eventprint = "You were thrusted upwards!",
	namecol = SKINCOLOR_POPCORN,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				p.mo.momz = 15*FRACUNIT
			end
		end
	end,
})

-- Last place is Speedy!
ckAddEvent(ckEvents, {
	name = "Shoes",
	shortname = "SpeedLast",
	eventprint = "Last Place suddenly sped up!",
	namecol = SKINCOLOR_RED,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if (p.kartstuff[k_position] == chk.playercount) and (p and p.mo)
				K_DoSneaker(p)
				p.kartstuff[k_sneakertimer] = 5*TICRATE
			end
		end
	end,
})

-- Crush All
ckAddEvent(ckEvents, {
	name = "Intense Gravity",
	shortname = "CrushAll",
	eventprint = "Gravity intensified!",
	namecol = SKINCOLOR_RED,
	eventfunc = function(time)
		for p in players.iterate
			if (p and p.mo)
				p.mo.momz = $ - 100*FRACUNIT
				p.kartstuff[k_squishedtimer] = $ + TICRATE
			end
		end
	end,
})

-- Crush Random
ckAddEvent(ckEvents, {
	name = "Crushed Someone",
	shortname = "CrushRand",
	eventprint = "Someone felt the effect of Gravity!",
	namecol = SKINCOLOR_RED,
	eventfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
		pl.mo.momz = -100*FRACUNIT
		pl.kartstuff[k_squishedtimer] = $ + TICRATE
	end,
})

-- Freeze All
ckAddEvent(ckEvents, {
	name = "Freeze",
	shortname = "FreezeAll",
	eventprint = "You were frozen! Mash accelerate, drift or item to break out!",
	namecol = SKINCOLOR_RED,
	cooldown = 5,
	eventfunc = function(time)
		for p in players.iterate
			if (p and p.mo)
				p.frozen = true
			end
		end
	end,
})

-- Icy Floor
ckAddEvent(ckEvents, {
	name = "Slippery Floor",
	shortname = "IcyFloor",
	eventprint = "The floor feels slipperier than usual.",
	namecol = SKINCOLOR_RED,
	candeathroulette = true,
	var = {"Slippery Floor", "icyfloor"},
	eventthink = function()
		for p in players.iterate
			if (p and p.mo)
				if chk.icyfloor >= 1
					p.mo.friction = FRACUNIT
				end
			end
		end
		chk.icyfloor = $ - 1
	end,
	eventfunc = function(time)
		if time == nil
			chk.icyfloor = 30*TICRATE
		else
			chk.icyfloor = time*TICRATE
		end
	end
})

-- Max Spark Rate
ckAddEvent(ckEvents, {
	name = "Maximum Spark Rate",
	shortname = "MaxSpark",
	eventprint = "Sparkrate was maximised!",
	namecol = SKINCOLOR_ORANGE,
	candeathroulette = true,
	var = {"Max Spark Rate", "maxspark"},
	eventthink = function()
		for p in players.iterate
			if chk.maxspark >= 1 and p.mo
				if p.kartstuff[k_driftcharge] > 2 then
					p.kartstuff[k_driftcharge] = 9000
				end
			end
		end
		chk.maxspark = $ - 1
	end,
	eventfunc = function(time)
		if time == nil
			chk.maxspark = 20*TICRATE
		else
			chk.maxspark = time*TICRATE
		end
	end,
})

-- No Spark Rate
ckAddEvent(ckEvents, {
	name = "No Spark Rate",
	shortname = "NoSpark",
	eventprint = "Sparkrate was nullified!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"No Spark-Rate", "nospark"},
	eventthink = function()
		for p in players.iterate
			if chk.nospark >= 1 and p.mo
				p.kartstuff[k_driftcharge] = 0
			end
		end
		chk.nospark = $ - 1
	end,
	eventfunc = function(time)
		if time == nil
			chk.nospark = 20*TICRATE
		else
			chk.nospark = time*TICRATE
		end
	end,
})

-- Always Drift
ckAddEvent(ckEvents, {
	name = "Perm Drift",
	shortname = "AlwaysDrift",
	eventprint = "Your kart keeps drifting!",
	namecol = SKINCOLOR_FLAME,
	candeathroulette = true,
	battlemode = false,
	var = {"Perma Drift", "alwaysdrift"},
	eventthink = function()
		for p in players.iterate
			if chk.alwaysdrift >= 1 and p.mo
				p.kartstuff[k_drift] = 2
				p.kartstuff[k_driftcharge] = 0
			end
		end
		chk.alwaysdrift = $ - 1	
	end,
	eventfunc = function(time)
		if time == nil
			chk.alwaysdrift = 10*TICRATE
		else
			chk.alwaysdrift = time*TICRATE
		end
	end,
})

-- Always Item
ckAddEvent(ckEvents, {
	name = "Item Spam",
	shortname = "AlwaysItem",
	eventprint = "Constant items!",
	namecol = SKINCOLOR_RED,
	candeathroulette = true,
	var = {"Item Spam", "alwaysitem"},
	eventthink = function()
		for p in players.iterate
			if chk.alwaysitem >= 1 and p.kartstuff[k_itemamount] <= 0
				p.kartstuff[k_itemroulette] = $ + TICRATE
			end
		end
		chk.alwaysitem = $ - 1
	end,
	eventfunc = function(time)
		if time == nil
			chk.alwaysitem = 10*TICRATE
		else
			chk.alwaysitem = time*TICRATE
		end
	end,
})

-- Invisibility
ckAddEvent(ckEvents, {
	name = "Invisibility",
	shortname = "Invisible",
	eventprint = "Everyone is invisible!",
	namecol = SKINCOLOR_RED,
	candeathroulette = true,
	var = {"Invisibility", "invis"},
	eventthink = function()
		for p in players.iterate
			if (chk.invis >= 1) and (p and p.mo)
				p.mo.flags2 = $|MF2_DONTDRAW
			end
		end
		chk.invis = $ - 1
	end,
	eventfunc = function(time)
		if time == nil
			chk.invis = 10*TICRATE
		else
			chk.invis = time*TICRATE
		end
	end,
})

-- Turn off or on the lights
ckAddEvent(ckEvents, {
	name = "Lights",
	shortname = "Lights",
	namecol = SKINCOLOR_YELLOW,
	var = {"Lights", "lightsoff"},
	eventthink = function()
		if chk.lightsoff >= 1
			chk.lightsoff = $ - 1
			if chk.lightsoff <= 0
				P_SetupLevelSky(mapheaderinfo[gamemap].skynum)
				for sector in sectors.iterate do
					sector.lightlevel = $*2
				end
			end
		end
	end,
	eventfunc = function(time)
		if chk.lightsoff <= 0
			for sector in sectors.iterate do
				sector.lightlevel = $/2
			end
			P_SetupLevelSky(6)
			if time
				chk.lightsoff = time*TICRATE
			else
				chk.lightsoff = 40*TICRATE
			end
		else
			P_SetupLevelSky(mapheaderinfo[gamemap].skynum)
			chk.lightsoff = 1
		end
	end,
})

-- Bumpfuck
ckAddEvent(ckEvents, {
	name = "Bump Death",
	shortname = "BumpKill",
	eventprint = "For your sake... don't bonk.",
	namecol = SKINCOLOR_RED,
	candeathroulette = true,
	var = {"Bump Death", "bumpfuck"},
	eventthink = function()
		if chk.bumpfuck >= 1
			chk.bumpfuck = $ - 1
		end
	end,
	eventpthink = function(p)
		if not p.spectator
			if chk.bumpfuck >= 1
			and (p.mo.eflags & MFE_JUSTBOUNCEDWALL or p.kartstuff[k_justbumped] >= 1)
			and p.kartstuff[k_growshrinktimer] <= 0
			and p.playerstate == PST_LIVE
			and not p.exiting
			and not p.kartstuff[k_invincibilitytimer]
				K_SpawnMineExplosion(p.mo, p.mo.color)
				P_KillMobj(p.mo)
				S_StartSound(p.mo, sfx_s3k4e)
			end
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.bumpfuck = 20*TICRATE
		else
			chk.bumpfuck = time*TICRATE
		end
	end,
})

-- Screenshake
ckAddEvent(ckEvents, {
	name = "Screenshake",
	shortname = "Screenshake",
	eventprint = "The screen became unstable!",
	namecol = SKINCOLOR_BROWN,
	candeathroulette = true,
	battlemode = false,
	eventfunc = function(time)
		if time == nil
			P_StartQuake(200*FRACUNIT, 5*TICRATE)
		else
			P_StartQuake(200*FRACUNIT, time*TICRATE)
		end
	end,
})

-- Kansei Dorifto!
ckAddEvent(ckEvents, {
	name = "Dorifto",
	shortname = "Dorifto",
	eventprint = "Your drifting style was changed!",
	namecol = SKINCOLOR_ORANGE,
	candeathroulette = true,
	var = {"Dorifto", "dorifto"},
	eventthink = function()
		if chk.dorifto >= 1
			chk.dorifto = $ - 1
		end
	end,
	eventpthink = function(p)
		if chk.dorifto >= 1
			if p.kartstuff[k_driftcharge] > 2 then
				p.kartstuff[k_driftcharge] = 0 
				p.kartstuff[k_driftboost] = TICRATE
			end
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.dorifto = 20*TICRATE
		else
			chk.dorifto = time*TICRATE
		end
	end,
})

-- Auto Accel
ckAddEvent(ckEvents, {
	name = "Auto Accel",
	shortname = "AutoAccel",
	eventprint = "Your acceleration button is broken!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Auto-Accel", "autoaccel"},
	eventthink = function()
		if chk.autoaccel >= 1
			chk.autoaccel = $ - 1
		end
	end,
	eventpcmd = function(p, cmd)
		if chk.autoaccel >= 1 and p.mo and p.mo.valid
			cmd.forwardmove = 50
			cmd.buttons = $|BT_ACCELERATE
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.autoaccel = 20*TICRATE
		else
			chk.autoaccel = time*TICRATE
		end
	end,
})

-- Heavy Gravity
ckAddEvent(ckEvents, {
	name = "Heavy Gravity",
	shortname = "HeavyGravity",
	eventprint = "Gravity got stronger!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Heavy Gravity", "heavygravity"},
	eventpthink = function(p)
		if chk.heavygravity >= 1 and p.mo
			if P_IsObjectOnGround(p.mo) == false
				P_SetObjectMomZ(p.mo, -gravity, true)
			end
		end
	end,
	eventthink = function()
		if chk.heavygravity >= 1
			chk.heavygravity = $ - 1
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.heavygravity = 20*TICRATE
		else
			chk.heavygravity = time*TICRATE
		end
	end,
})

-- Low Gravity
ckAddEvent(ckEvents, {
	name = "Low Gravity",
	shortname = "LowGravity",
	eventprint = "Gravity got weaker!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Low Gravity", "lowgravity"},
	eventpthink = function(p)
		if chk.lowgravity >= 1 and p.mo
			if P_IsObjectOnGround(p.mo) == false
				P_SetObjectMomZ(p.mo, (gravity/2)/1, true)
			end
		end
	end,
	eventthink = function()
		if chk.lowgravity >= 1
			chk.lowgravity = $ - 1
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.lowgravity = 20*TICRATE
		else
			chk.lowgravity = time*TICRATE
		end
	end,
})

-- Bouncy
ckAddEvent(ckEvents, {
	name = "Bouncy",
	shortname = "Bouncy",
	eventprint = "Your kart feels bouncy!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Bouncy", "bouncy"},
	eventpthink = function(p)
		if (p and p.mo) and chk.bouncy >= 1
			if P_IsObjectOnGround(p.mo)
				P_SetObjectMomZ(p.mo, 20*FRACUNIT)
				P_Thrust(p.mo, p.mo.angle, 20*FRACUNIT)
			end
		end
	end,
	eventthink = function()
		if chk.bouncy >= 1
			chk.bouncy = $ - 1
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.bouncy = 20*TICRATE
		else
			chk.bouncy = time*TICRATE
		end
	end,
})

-- Random Player gets an iceball
ckAddEvent(ckEvents, {
	name = "Random Item",
	shortname = "IceballRand",
	eventprint = "A Random Player got an Ice Ball!",
	namecol = SKINCOLOR_BLUE,
	battlemode = true,
	eventfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local p = possibleplayers[P_RandomRange(1, #possibleplayers)]
		p.kartstuff[k_itemroulette] = 0
		p.kartstuff[k_itemamount] = 0
		p.hasiceball = true
	end,
})

-- Random Player gets a Hyper Orbinaut
ckAddEvent(ckEvents, {
	name = "Random Item",
	shortname = "HyperOrbinautRand",
	eventprint = "A Random Player got a stronger Orbinaut!",
	namecol = SKINCOLOR_GRAY,
	battlemode = true,
	eventfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
		pl.kartstuff[k_itemamount] = 0
		pl.hashyperorb = $ + 1
	end,
})

-- Random Player gets a Giant Banana
ckAddEvent(ckEvents, {
	name = "Random Item",
	shortname = "GiantBananaRand",
	eventprint = "A Random Player got a Giant Banana!",
	namecol = SKINCOLOR_GRAY,
	battlemode = true,
	eventfunc = function(time)
		local possibleplayers = {}
		for p in players.iterate
			if p and p.mo then table.insert(possibleplayers, p) end
		end

		local pl = possibleplayers[P_RandomRange(1, #possibleplayers)]
		pl.kartstuff[k_itemamount] = 0
		pl.giantbananas = $ + 1
	end,
})

-- Higher Max Speed
ckAddEvent(ckEvents, {
	name = "Faster",
	shortname = "UpSpeed",
	eventprint = "Top Speed was risen!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Faster!", "upspeed"},
	eventpthink = function(p)
		if chk.upspeed >= 1 and p.mo
			if p.kartstuff[k_offroad] == 0
				p.kartstuff[k_boostpower] = FRACUNIT + FRACUNIT/3 
			end
		end
	end,
	eventthink = function()
		if chk.upspeed >= 1 then chk.upspeed = $-1 end
	end,
	eventfunc = function(time)
		chk.upspeed = time and time*TICRATE or 20*TICRATE
	end,
})

-- No seeing item!
ckAddEvent(ckEvents, {
	name = "Can't See Item",
	shortname = "UnseenItem",
	eventprint = "Items cannot be seen!",
	namecol = SKINCOLOR_ORANGE,
	battlemode = true,
	var = {"Item Invis", "unseenitem"},
	soundplay = sfx_slip,
	eventthink = function()
		if chk.unseenitem >= 1
			hud.disable("item")
			chk.unseenitem = $ - 1
		else
			hud.enable("item")
		end
	end,
	eventfunc = function(time)
		chk.unseenitem = time and time*TICRATE or 30*TICRATE
	end,
})

-- Lower Max Speed
ckAddEvent(ckEvents, {
	name = "Slower",
	shortname = "DownSpeed",
	eventprint = "Top Speed was lowered!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Slower!", "downspeed"},
	eventpthink = function(p)
		if chk.downspeed >= 1 and p.mo
			if p.kartstuff[k_offroad] == 0
				p.kartstuff[k_boostpower] = FRACUNIT - FRACUNIT/3 
			end
		end
	end,
	eventthink = function()
		if chk.downspeed >= 1 then chk.downspeed = $-1 end
	end,
	eventfunc = function(time)
		chk.downspeed = time and time*TICRATE or 20*TICRATE
	end,
})

-- Random Item
ckAddEvent(ckEvents, {
	name = "Random Item",
	shortname = "RandItem",
	eventprint = "Random Item!",
	namecol = SKINCOLOR_BLUE,
	candeathroulette = true,
	eventfunc = function(time)
		for p in players.iterate
			p.kartstuff[k_itemtype] = P_RandomRange(1, 15)
			p.kartstuff[k_itemamount] = 1
		end
	end,
})

-- Momentum Drained.
ckAddEvent(ckEvents, {
	name = "Loss of Momentum",
	shortname = "StopAll",
	eventprint = "You lost your momentum.",
	namecol = SKINCOLOR_POPCORN,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo
				P_InstaThrust(p.mo, p.mo.angle, 0)
				P_SetObjectMomZ(p.mo, 0)
			end
		end
	end,
})

-- Bunny Hop
ckAddEvent(ckEvents, {
	name = "Bunny Hop",
	shortname = "BunnyHop",
	eventprint = "Your kart starts jumping!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	battlemode = false,
	var = {"Bunny-Hop", "permajumpdrift"},
	eventthink = function()
		if chk.permajumpdrift >= 1
			for p in players.iterate
				if p.mo and p
					if P_IsObjectOnGround(p.mo)
						S_StartSound(p.mo, sfx_s3k56)
						if (p.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(p.mo, 2*FRACUNIT)
						else
							P_SetObjectMomZ(p.mo, 5*FRACUNIT)
						end
					end
				end
			end
			chk.permajumpdrift = $ - 1
		end
	end,
	eventfunc = function(time)
		chk.permajumpdrift = time and time*TICRATE or 20*TICRATE
	end,
})

-- Random Angle
ckAddEvent(ckEvents, {
	name = "Random Angle",
	shortname = "RandAng",
	eventprint = "Your angle was randomized.",
	namecol = SKINCOLOR_POPCORN,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo and p.mo.valid
				p.mo.angle = P_RandomRange(0, 360)*ANG1
			end
		end
	end,
})

-- Random Scale
ckAddEvent(ckEvents, {
	name = "Random Scale",
	shortname = "RandScale",
	eventprint = "Your scale was randomized!",
	namecol = SKINCOLOR_GRAY,
	candeathroulette = true,
	var = {"Random Scale", "randscale"},
	eventthink = function()
		if chk.randscale >= 1
			chk.randscale = $-1
			if chk.randscale <= 0
				for p in players.iterate
					if p.mo and p.mo.valid then p.mo.destscale = FRACUNIT end
				end
			end
		end
	end,
	eventfunc = function(time)
		chk.randscale = time and time*TICRATE or 30*TICRATE
		
		for p in players.iterate
			if p.mo and p.mo.valid then p.mo.destscale = P_RandomRange(1, 4)*P_RandomRange(5, FRACUNIT) end
		end
	end,
})

-- Random Scale
ckAddEvent(ckEvents, {
	name = "Force Gliding",
	shortname = "ForceGlide",
	eventprint = "You begin rising!",
	namecol = SKINCOLOR_ORANGE,
	candeathroulette = true,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo and p.mo.valid
				forceGlide(p.mo, p.mo.angle)
			end
		end
	end,
})

-- Random Angle
ckAddEvent(ckEvents, {
	name = "Traps",
	shortname = "Traps",
	eventprint = "Beware of the Traps!",
	namecol = SKINCOLOR_POPCORN,
	eventfunc = function(time)
		for p in players.iterate
			if p and p.mo and p.mo.valid
				for i = 1, 5
					local x, y, z = P_RandomRange(-500, 500)*FRACUNIT, P_RandomRange(-500, 500)*FRACUNIT, p.mo.z
					local spike = P_SpawnMobj(p.mo.x + x, p.mo.y + y, z, MT_STEALTHSPIKE)
				end
			end
		end
	end,
})

------------------------
-- Rare Events, oh no --
------------------------

-- Explode Last
ckAddRareEvent(ckRareEvents, {
	name = "Explode Last",
	shortname = "ExplodeLast",
	eventprint = "Last place was blown up!",
	namecol = SKINCOLOR_RED,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == chk.playercount and p and p.mo
				K_SpawnMineExplosion(p.mo, p.mo.color)
				p.kartstuff[k_spinouttimer] = 3*TICRATE
				P_StartQuake(30*FRACUNIT, TICRATE/2)
				P_InstaThrust(p.mo, p.mo.angle, 0)
				P_SetObjectMomZ(p.mo, 10*FRACUNIT)
			end
		end
	end,
})

-- Spawn Brak Eggman
ckAddRareEvent(ckRareEvents, {
	name = "Brak Eggman",
	shortname = "SpawnBrak",
	eventprint = "Brak Eggman appeared!",
	namecol = SKINCOLOR_RED,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == 1 and (p and p.mo)
				P_SpawnMobj(p.mo.x+P_RandomRange(-500, 500)<<FRACBITS, p.mo.y+P_RandomRange(-500, 500)<<FRACBITS, p.mo.z + 20*FRACUNIT, MT_CYBRAKDEMON)
			end
		end
	end,
})

-- Spawn Tornado
ckAddRareEvent(ckRareEvents, {
	name = "Tornado Summoned",
	shortname = "SpawnTornado",
	eventprint = "A tornado formed!",
	namecol = SKINCOLOR_GRAY,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == 1 and (p and p.mo)
				local tornado = P_SpawnMobj(p.mo.x+P_RandomRange(-500, 500)<<FRACBITS, p.mo.y+P_RandomRange(-500, 500)<<FRACBITS, p.mo.z + 20*FRACUNIT, MT_TORNADO)
				tornado.fuse = 30*TICRATE
			end
		end
	end,
})

-- BananaRain
freeslot("sfx_obanan")

ckAddRareEvent(ckRareEvents, {
	name = "Banana Rain",
	shortname = "BananaRain",
	eventprint = "Oooh! Banana!",
	namecol = SKINCOLOR_GRAY,
	soundplay = sfx_obanan,
	cooldown = 10,
	candeathroulette = true,
	var = {"Banana-Rain", "bananarain"},
	eventfunc = function(time)
		if time == nil
			chk.bananarain = 10*TICRATE
		else
			chk.bananarain = time*TICRATE
		end
	end,
})

-- TacoRain
ckAddRareEvent(ckRareEvents, {
	name = "Taco Rain",
	shortname = "TacoRain",
	eventprint = "It's raining tacos!",
	namecol = SKINCOLOR_GRAY,
	cooldown = 10,
	candeathroulette = true,
	var = {"Taco-Rain", "tacorain"},
	eventfunc = function(time)
		if time == nil
			chk.tacorain = 10*TICRATE
		else
			chk.tacorain = time*TICRATE
		end
	end,
})

-- SpringRain
ckAddRareEvent(ckRareEvents, {
	name = "Spring Rain",
	shortname = "SpringRain",
	eventprint = "It's raining springs!",
	namecol = SKINCOLOR_YELLOW,
	cooldown = 10,
	candeathroulette = true,
	var = {"Spring-Rain", "springtimer"},
	eventfunc = function(time)
		if time == nil
			chk.springtimer = 10*TICRATE
		else
			chk.springtimer = time*TICRATE
		end
	end,
})

-- UltraLast
ckAddRareEvent(ckRareEvents, {
	name = "Prize for Last",
	shortname = "UltraLast",
	eventprint = "Last Place was grown and got invincibility!",
	namecol = SKINCOLOR_YELLOW,
	cooldown = 5,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == chk.playercount and (p and p.mo)
				p.mo.destscale = p.mo.scale*3
				p.kartstuff[k_growshrinktimer] = 20*TICRATE
				p.kartstuff[k_invincibilitytimer] = 20*TICRATE
			end
		end
	end,
})

-- SPBs for those that aren't first.
ckAddRareEvent(ckRareEvents, {
	name = "SPBs Incoming",
	shortname = "SPBNotFirst",
	eventprint = "SPBs Incoming!",
	namecol = SKINCOLOR_NICKEL,
	cooldown = 10,
	soundplay = sfx_noooo3,
	battlemode = false,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] < 1 and (p and p.mo)
				local spb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + 300*FRACUNIT, MT_SPB)
				spb.color = p.mo.color
				spb.colorized = true
				for p in players.iterate
					if p.kartstuff[k_position] == 1 then spb.target = p.mo end
				end
			else
				p.kartstuff[k_itemtype] = 2
				p.kartstuff[k_itemamount] = 3		
			end
		end
	end,
})

-- Avalanche
ckAddRareEvent(ckRareEvents, {
	name = "Avalanche",
	shortname = "Avalanche",
	eventprint = "It's raining rocks!",
	namecol = SKINCOLOR_BROWN,
	cooldown = 10,
	candeathroulette = true,
	var = {"Avalanche", "rockrain"},
	eventfunc = function(time)
		P_StartQuake(3*FRACUNIT, 10*TICRATE)
		if time == nil
			chk.rockrain = 10*TICRATE
		else
			chk.rockrain = time*TICRATE
		end
	end,
})

-- Control Invert
ckAddRareEvent(ckRareEvents, {
	name = "Inverted Controls",
	shortname = "InvertControls",
	eventprint = "Your controls were inverted!",
	namecol = SKINCOLOR_GRAY,
	cooldown = 20,
	candeathroulette = true,
	var = {"Control Invert", "controlinvert"},
	eventpcmd = function(p, cmd)
		if chk.controlinvert >= 1
			if (cmd.buttons & BT_ACCELERATE)
				cmd.buttons = $|BT_BRAKE
				cmd.forwardmove = -50
			elseif (cmd.buttons & BT_BRAKE)
				cmd.buttons = $|BT_ACCELERATE
				cmd.forwardmove = 50
			end

//			if (cmd.angleturn >= 50)
//				cmd.angleturn = -50
//			elseif (cmd.angleturn <= -50)
//				cmd.angleturn = 50
//			end
		end
	end,
	eventthink = function()
		if chk.controlinvert >= 1
			chk.controlinvert = $ - 1
		end
	end,
	eventfunc = function(time)
		if time == nil
			chk.controlinvert = 30*TICRATE
		else
			chk.controlinvert = time*TICRATE
		end
	end,
})

-- Item Rain
ckAddRareEvent(ckRareEvents, {
	name = "Item Rain",
	shortname = "ItemRain",
	eventprint = "It's raining items!",
	namecol = SKINCOLOR_YELLOW,
	cooldown = 10,
	candeathroulette = true,
	var = {"Item Rain", "itemrain"},
	eventfunc = function(time)
		if time == nil
			chk.itemrain = 10*TICRATE
		else
			chk.itemrain = time*TICRATE
		end
	end,
})

-- Badnik Rain
ckAddRareEvent(ckRareEvents, {
	name = "Badnik Rain",
	shortname = "BadnikRain",
	eventprint = "It's raining badniks!",
	namecol = SKINCOLOR_RED,
	cooldown = 15,
	candeathroulette = true,
	var = {"Badnik Rain", "badnikrain"},
	eventfunc = function(time)
		if time == nil
			chk.badnikrain = 10*TICRATE
		else
			chk.badnikrain = time*TICRATE
		end
	end,
})

-- 1st gets banana jackpot
ckAddRareEvent(ckRareEvents, {
	name = "Banana Jackpot",
	shortname = "100Bananas",
	eventprint = "First Place hit the banana jackpot!",
	namecol = SKINCOLOR_YELLOW,
	eventfunc = function(time)
		for p in players.iterate
			if p.kartstuff[k_position] == 1
				p.kartstuff[k_itemtype] = KITEM_BANANA
				p.kartstuff[k_itemamount] = 100
			end
		end
	end,
})

-- Random Player gets 3 stronger orbinauts.
ckAddRareEvent(ckRareEvents, {
	name = "Stronger Orbinauts",
	shortname = "3HyperOrbinautRand",
	eventprint = "A Random Player got 3 stronger Orbinauts!",
	namecol = SKINCOLOR_GRAY,
	battlemode = true,
	eventfunc = function(time)
		local node = P_RandomKey(chk.playercount)
		players[node].kartstuff[k_itemamount] = 0
		players[node].hashyperorb = $ + 3
	end,
})

-- Hail
ckAddRareEvent(ckRareEvents, {
	name = "Hail",
	shortname = "Hail",
	eventprint = "It's raining freezing cold ice!",
	namecol = SKINCOLOR_CYAN,
	cooldown = 10,
	candeathroulette = true,
	var = {"Hail", "hail"},
	eventfunc = function(time)
		if time == nil
			chk.hail = 15*TICRATE
		else
			chk.hail = time*TICRATE
		end
	end,
})

-- Fire Rain
ckAddRareEvent(ckRareEvents, {
	name = "Fire Rain",
	shortname = "FireRain",
	eventprint = "It's raining burning hot fire!",
	namecol = SKINCOLOR_RED,
	cooldown = 10,
	candeathroulette = true,
	var = {"Fire Rain", "firerain"},
	eventfunc = function(time)
		if time == nil
			chk.firerain = 15*TICRATE
		else
			chk.firerain = time*TICRATE
		end
	end,
})