rawset(_G, "ckAddEvent", function(whyisthishereagain, eventfuncs)
	local tablelength = #ckEvents
	table.insert(ckEvents, eventfuncs)
	if gametype == GT_BATTLE and eventfuncs.battlemode ~= false
		table.insert(ckBattleEvents, eventfuncs)
	end
	if #ckEvents > tablelength
		print("Added "..eventfuncs.shortname.." to the event table.")
	else
		assert(nil, "This event already exists!")
		print("Something went wrong here... "..eventfuncs.shortname.." was not added.")
	end
end)

rawset(_G, "ckAddRareEvent", function(whyisthishereagain, eventfuncs)
	local tablelength = #ckRareEvents
	table.insert(ckRareEvents, eventfuncs)
	if gametype == GT_BATTLE and eventfuncs.battlemode ~= false
		table.insert(ckBattleRareEvents, eventfuncs)
	end
	if #ckRareEvents > tablelength
		print("Added a certain event to the rare event table.")
	else
		assert(nil, "This rare event already exists!")
		print("Something went wrong here... "..eventfuncs.shortname.." was not added.")
	end
end)

local cv_rareeventchance = CV_RegisterVar({
  name = "ck_rareeventchance",
  defaultvalue = 8,
  flags = CV_NETVAR,
  PossibleValue = {MIN = 0, MAX = 100},
})

rawset(_G, "ckPickEvent", function()
	local chance = ckEventChance()
	if chance == 1 and cv_deathroulette.value == 1
		ckStartRoulette()
	elseif chance <= cv_rareeventchance.value
		if gametype == GT_BATTLE
			ckBattleRareEvent(P_RandomRange(1, #ckBattleRareEvents))
		else
			ckRareEvent(P_RandomRange(1, #ckRareEvents))
		end
	else
		if gametype == GT_BATTLE
			ckBattleEvent(P_RandomRange(1, #ckBattleEvents))
		else
			ckEvent(P_RandomRange(1, #ckEvents))
		end
	end	
end)

rawset(_G, "ckEvent", function(event)
	if ckEvents[event].soundplay == nil
		S_StartSound(nil, sfx_kc48)
	else
		S_StartSound(nil, ckEvents[event].soundplay)
	end
	if ckEvents[event].cooldown == nil
		chaosmod.eventcooldown = 3
	else
		chaosmod.eventcooldown = ckEvents[event].cooldown
	end
	if ckEvents[event].eventprint ~= nil
--		print(ckEvents[event].eventprint)
		chaosmod.eventprint = ckEvents[event].eventprint
	else
		chaosmod.eventprint = ""
	end
	ckEvents[event].eventfunc()
	if ckEvents[event].name ~= nil
		chaosmod.eventdisplay = ckEvents[event].name
	else
		chaosmod.eventdisplay = "Missing Name!"
	end
end)

rawset(_G, "ckBattleEvent", function(event)
	if ckBattleEvents[event].soundplay == nil
		S_StartSound(nil, sfx_kc48)
	else
		S_StartSound(nil, ckBattleEvents[event].soundplay)
	end
	if ckBattleEvents[event].cooldown == nil
		chaosmod.eventcooldown = 3
	else
		chaosmod.eventcooldown = ckBattleEvents[event].cooldown
	end
	if ckBattleEvents[event].eventprint ~= nil
--		print(ckBattleEvents[event].eventprint)
		chaosmod.eventprint = ckBattleEvents[event].eventprint
	else
		chaosmod.eventprint = ""
	end
	ckBattleEvents[event].eventfunc()
	if ckBattleEvents[event].name ~= nil
		chaosmod.eventdisplay = ckBattleEvents[event].name
	else
		chaosmod.eventdisplay = "Missing Name!"
	end
end)

rawset(_G, "ckRareEvent", function(event)
	if ckRareEvents[event].soundplay == nil
		S_StartSound(nil, sfx_noooo2)
	else
		S_StartSound(nil, ckRareEvents[event].soundplay)
	end
	if ckRareEvents[event].cooldown == nil
		chaosmod.eventcooldown = 3
	else
		chaosmod.eventcooldown = ckRareEvents[event].cooldown
	end
	if ckRareEvents[event].eventprint ~= nil
--		print(ckRareEvents[event].eventprint)
		chaosmod.eventprint = ckRareEvents[event].eventprint
	else
		chaosmod.eventprint = ""
	end
	ckRareEvents[event].eventfunc()
	if ckRareEvents[event].name ~= nil
		chaosmod.eventdisplay = ckRareEvents[event].name
	else
		chaosmod.eventdisplay = "Missing Name!"
	end
end)

rawset(_G, "ckBattleRareEvent", function(event)
	if ckBattleRareEvents[event].soundplay == nil
		S_StartSound(nil, sfx_noooo2)
	else
		S_StartSound(nil, ckBattleRareEvents[event].soundplay)
	end
	if ckBattleRareEvents[event].cooldown == nil
		chaosmod.eventcooldown = 3
	else
		chaosmod.eventcooldown = ckBattleRareEvents[event].cooldown
	end
	if ckBattleRareEvents[event].eventprint ~= nil
--		print(ckBattleRareEvents[event].eventprint)
		chaosmod.eventprint = ckBattleRareEvents[event].eventprint
	else
		chaosmod.eventprint = ""
	end
	ckBattleRareEvents[event].eventfunc()
	if ckBattleRareEvents[event].name ~= nil
		chaosmod.eventdisplay = ckBattleRareEvents[event].name
	else
		chaosmod.eventdisplay = "Missing Name!"
	end
end)

rawset(_G, "allEvents", function()
	local eventTable = {}

	for k,v in ipairs(ckEvents)
		table.insert(eventTable, v)
	end

	for k,v in ipairs(ckRareEvents)
		table.insert(eventTable, v)
	end
	
	return eventTable
end)