local ck = chaosmod

addHook("NetVars", function(net)
	ck.eventtimer = net($)
	ck.eventcooldown = net($)
end)

addHook("ThinkFrame", function()
	if cv_chaoskart.value == 1
		-- Get ck.playercount
		ck.playercount = 0
		for p in players.iterate
			if p.mo and p.mo.valid
				ck.playercount = $+1
			end
		end
		
		if leveltime < 7*TICRATE
			ck.eventtimer = cv_starteventtime.value
		end

		-- Run events
		if ck.deathroulette == false
			if not (leveltime%35) and leveltime > 7*TICRATE
				if ck.eventcooldown >= 1
					ck.eventcooldown = $-1
				else
					ck.eventtimer = $-1
					if ck.eventtimer <= 0
						ck.eventtimer = cv_starteventtime.value
						ckPickEvent()
					end
				end
			end
		end
		
		-- Death Roulette
		ck.hudy = $ or 0
		ck.takeaway = $ or 1
		if ck.deathrouletteprepare >= 1*TICRATE and ck.hudy <= 20
			ck.hudy = $1 + ck.takeaway
			ck.takeaway = $1 + 1
		end
		
		-- Eventthink
		for i in pairs(ckEvents)
			if ckEvents[i].eventthink then ckEvents[i].eventthink() end
		end
		
		for i in pairs(ckRareEvents)
			if ckRareEvents[i].eventthink then ckRareEvents[i].eventthink() end
		end
		
		-- Eventplayerthink
		for p in players.iterate
			for i in pairs(ckEvents)
				if ckEvents[i].eventpthink then ckEvents[i].eventpthink(p) end
			end
			
			for i in pairs(ckRareEvents)
				if ckRareEvents[i].eventpthink then ckRareEvents[i].eventpthink(p) end
			end
		end
	end
	
	-- Other things
	for p in players.iterate
		-- Nothing here as of now :(
	end
end)

addHook("PlayerCmd", function(p, cmd)
	if cv_chaoskart.value == 1
		-- Eventpcmd
		for i in pairs(ckEvents)
			if ckEvents[i].eventpcmd then ckEvents[i].eventpcmd(p, cmd) end
		end
		
		for i in pairs(ckRareEvents)
			if ckRareEvents[i].eventpcmd then ckRareEvents[i].eventpcmd(p, cmd) end
		end
	end
end)

hud.add(function(v, p, cam)
	if cv_chaoskart.value == 1
		if ck.deathroulette == false
			local bomtime = ck.eventtimer*55/cv_starteventtime.value+(1/2)
			v.drawFill(80, 4, bomtime, 5, V_SNAPTOTOP|V_SNAPTOLEFT|1)
			v.drawFill(80, 5, bomtime, 3, V_SNAPTOTOP|V_SNAPTOLEFT|99)
			v.draw(69+bomtime, -2, v.cachePatch("FIRE"), V_SNAPTOTOP|V_SNAPTOLEFT) -- hehe, 69, nice.

			if ck.eventtimer <= (cv_starteventtime.value/3)
				v.draw(70, 0, v.cachePatch("TIMER4"), V_SNAPTOTOP|V_SNAPTOLEFT)
			elseif ck.eventtimer <= (cv_starteventtime.value/2)
				v.draw(70, 0, v.cachePatch("TIMER3"), V_SNAPTOTOP|V_SNAPTOLEFT)
			elseif ck.eventtimer <= (cv_starteventtime.value/2 + cv_starteventtime.value/4) 
				v.draw(70, 0, v.cachePatch("TIMER2"), V_SNAPTOTOP|V_SNAPTOLEFT)
			else
				v.draw(70, 0, v.cachePatch("TIMER1"), V_SNAPTOTOP|V_SNAPTOLEFT)
			end
		end

		if ck.eventcooldown >= 1
	--		if #ck.eventdisplay >= 15
	--			v.drawKartString(50, 30, ck.eventdisplay, V_SNAPTOLEFT|V_SNAPTOTOP, "thin")
	--		else
				v.drawKartString(52, 30, ck.eventdisplay, V_SNAPTOLEFT|V_SNAPTOTOP)
				if ck.deathroulette ~= true then v.drawString(50, 45, ck.eventprint, V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP, "small") end
	--		end
		else
			if ck.deathroulette == true
				v.drawString(78, 7-ck.hudy, ck.eventtimer, V_SNAPTOTOP|V_SNAPTOLEFT, "center")
			else
				v.drawString(78, 7, ck.eventtimer, V_SNAPTOTOP|V_SNAPTOLEFT, "center")
			end
		end
	end
	
	-- Display Tornado
	for mo in thinkers.iterate("mobj")
		if mo.type == MT_TORNADO
			v.drawOnMinimap(mo.x, mo.y, FRACUNIT, v.cachePatch("TORNDO"))
		end
		
		if ck.badnikrain > 0
			local possibleHazards = {MT_BLUECRAWLA, MT_REDCRAWLA, MT_GFZFISH, MT_JETTBOMBER, MT_JETTGUNNER, MT_CRAWLACOMMANDER, MT_SKIM, MT_POPUPTURRET, MT_ROBOHOOD, MT_FACESTABBER, MT_EGGGUARD, MT_GSNAPPER}
			
			for i = 1, #possibleHazards
				if mo.type == possibleHazards[i]
					v.drawOnMinimap(mo.x, mo.y, FRACUNIT, v.cachePatch("YIKES"))
				end
			end
		end
	end
	
	-- Currently active events
	local curY = 26
	local events = allEvents()
	for k,val in ipairs(events)
		if val.var and chaosmod[val.var[2]] and chaosmod[val.var[2]] > 0
			v.drawString(320, curY, val.var[1]..": "..G_TicsToSeconds(chaosmod[val.var[2]]), V_SNAPTOTOP|V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE, "small-right")
			curY = $+5
		end
	end
end, game)

-- Synch all of the variables
addHook("NetVars", function(net)
	local events = allEvents()
	
	for k,v in pairs(events)
		if v.var and v.var[2] then chaosmod[v.var[2]] = net($) end
	end
	
	// We're... missing something.
	chaosmod.windangle = net($)
	chaosmod.originalholder = net($)
	
	// OKay now we're good :)
end)