-------------------------
-- Regular Perm Effects--
-------------------------

addHook("NetVars", function(net)
	chaosmod.nighttime = net($)
	chaosmod.sunlight = net($)
end)

// Icy Floor
ckAddPermEffect({
	name = "Slippery Floor",
	desc = "The floor is Icy!",
	startsound = sfx_ideya,
	synchnewjoiners = true,
	starteffect = function()
		for sector in sectors.iterate
			if (sector.floorpic ~= "F_SKY1" or sector.floorpic ~= "PIT")
				sector.floorpic = "ICEFLRA"
			end
			for rover in sector.ffloors()
				if rover.valid and (rover.toppic ~= "F_SKY1" or rover.toppic ~= "PIT")
					rover.toppic = "ICEFLRA"
				end
			end
		end
		P_SwitchWeather(2)
	end,
	effect = function()		
		for p in players.iterate
			if not p.spectator and p.valid then p.mo.friction = FRACUNIT end
		end
	end,
})

// Hail
ckAddPermEffect({
	name = "Hail",
	desc = "It's Raining Ice!",
	encoredesc = "It's Raining Even More Ice!",
	startsound = sfx_ideya,
	effect = function()
		local possiblePlayers = {}
		for p in players.iterate
			if (p and p.mo) and not p.spectator then table.insert(possiblePlayers, p.mo) end
		end
		if #possiblePlayers and not(leveltime%10)
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local ice = P_SpawnMobj(tmo.x+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.y+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_ICEBALL)
			ice.noparticles = true
			ice.fuse = 10*TICRATE
		end
	end,
	encoreeffect = function()
		local possiblePlayers = {}
		for p in players.iterate
			if (p and p.mo) and not p.spectator then table.insert(possiblePlayers, p.mo) end
		end
		if #possiblePlayers
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local ice = P_SpawnMobj(tmo.x+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.y+P_RandomRange(-1500, 1500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_ICEBALL)
			ice.noparticles = true
			ice.fuse = 15*TICRATE
		end
	end,
})

// Windy
ckAddPermEffect({
	name = "Windy",
	desc = "It's very windy!",
	encoredesc = "It's extremely windy!",
	startsound = sfx_ideya,
	synchnewjoiners = true,
	starteffect = function()
		chaosmod.windangle = P_RandomRange(0, 360)*ANG1
	end,
	effect = function()
		for p in players.iterate
			if p.mo and p.mo.valid
				p.mo.momx = $ - cos(chaosmod.windangle) / 6
				p.mo.momy = $ - sin(chaosmod.windangle) / 6
			end
		end
	end,
	encoreeffect = function()
		for p in players.iterate
			if p.mo and p.mo.valid
				p.mo.momx = $ - cos(chaosmod.windangle) / 3
				p.mo.momy = $ - sin(chaosmod.windangle) / 3
			end
		end
	end,
})

// Quake
ckAddPermEffect({
	name = "Earthquake",
	desc = "The floor is shaking!",
	startsound = sfx_ideya,
	effect = function()
		P_StartQuake(3*FRACUNIT, TICRATE)
	end,
	mobjthinker = function(mo)
		if mo and mo.valid
			local itemmo = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_GIANTBANANA, MT_HORB}
			if P_IsObjectOnGround(mo)
				for i in pairs(itemmo)
					if mo.type == itemmo[i]
						P_SetObjectMomZ(mo, P_RandomRange(1, 10)*FRACUNIT)
						P_Thrust(mo, P_RandomRange(0, 360)*ANG1, P_RandomRange(1, 4)*FRACUNIT)
					end
				end
			end
		end
	end,
})

// Increased Speed
ckAddPermEffect({
	name = "Speed Up",
	desc = "Your speed is increased!",
	encoredesc = "Your speed is doubled!",
	startsound = sfx_ideya,
	effect = function()
		for p in players.iterate
			if p.mo and p.mo.valid then p.kartstuff[k_boostpower] = 3*FRACUNIT/2 end
		end
	end,
	encoreeffect = function()
		for p in players.iterate
			if p.mo and p.mo.valid then p.kartstuff[k_boostpower] = 2*FRACUNIT end
		end
	end,
})

// Night Time
ckAddPermEffect({
	name = "Night Time",
	desc = "Night Time Racing",
	encoredesc = "Midnight Racing",
	startsound = sfx_ideya,
	synchnewjoiners = true,
	starteffect = function()
		for sector in sectors.iterate do
			sector.lightlevel = ($*2)/3
		end
		chaosmod.nighttime = true
		P_SetupLevelSky(6)
	end,
})

// Sunlight
ckAddPermEffect({
	name = "Sunlight",
	desc = "Items burn!",
	encoredesc = "Items explode!",
	startsound = sfx_ideya,
	synchnewjoiners = true,
	starteffect = function()
		for sector in sectors.iterate do
			sector.lightlevel = $+($/2)
		end
		chaosmod.sunlight = true
	end,
	mobjthinker = function(mo)
		local itemmo = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_GIANTBANANA, MT_HORB}
		if mo.valid
			for i in pairs(itemmo)
				if mo.type == itemmo[i]
					mo.colorized = true
					mo.color = SKINCOLOR_ORANGE
					local smoke = P_SpawnMobj(mo.x+P_RandomRange(-25, 25)*mo.scale, mo.y+P_RandomRange(-25, 25)*mo.scale, mo.z+P_RandomRange(5, 30)*mo.scale, MT_SMOKE)
					if not S_SoundPlaying(mo, sfx_kc51) then S_StartSound(mo, sfx_kc51) end
				end
			end
		end
	end,
	spineffect = function(p, i, s)
		local itemmo = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_GIANTBANANA, MT_HORB}
		if (p.valid and p.mo.valid)
			for m in pairs(itemmo)
				if i.type == itemmo[m]
					p.kartstuff[k_spinouttimer] = $*2
					if encoremode == true
						p.kartstuff[k_spinouttimer] = $+TICRATE
						K_SpawnMineExplosion(i, i.color)
						local explode = P_SpawnMobj(i.x, i.y, i.z, MT_SPBEXPLOSION)
						explode.scale = i.scale
					end
					p.onfire = 10*TICRATE
				end
			end
		end
	end,
	xpldeffect = function(p, i, s)
		local itemmo = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_GIANTBANANA, MT_HORB}
		if (p.valid and p.mo.valid)
			for m in pairs(itemmo)
				if i.type == itemmo[m]
					p.kartstuff[k_wipeoutslow] = $*2
					if encoremode == true
						p.kartstuff[k_wipeoutslow] = $+TICRATE
						K_SpawnMineExplosion(i, i.color)
						local explode = P_SpawnMobj(i.x, i.y, i.z, MT_SPBEXPLOSION)
						explode.scale = i.scale
					end
					p.onfire = 10*TICRATE
				end
			end
		end
	end,
})

// Permanent Shrink
ckAddPermEffect({
	name = "Permashrink",
	desc = "Permanent Shrink!",
	encoredesc = "Even Smaller! Good luck!",
	startsound = sfx_ideya,
	effect = function()
		for p in players.iterate
			if not p.spectator and (p and p.mo)
				if p.kartstuff[k_growshrinktimer] >= 1
					p.mo.scale = FRACUNIT
					p.kartstuff[k_boostpower] = FRACUNIT+((FRACUNIT/4)*3)
				elseif p.kartstuff[k_growshrinktimer] <= -1
					p.mo.scale = FRACUNIT/4
				else
					p.mo.scale = FRACUNIT/2
					p.kartstuff[k_boostpower] = FRACUNIT+(FRACUNIT/2)
				end
			end
		end
	end,
	encoreeffect = function()
		for p in players.iterate
			if not p.spectator and (p and p.mo)
				if p.kartstuff[k_growshrinktimer] >= 1
					p.mo.scale = FRACUNIT/2
					p.kartstuff[k_boostpower] = FRACUNIT+((FRACUNIT/4)*3)
				elseif p.kartstuff[k_growshrinktimer] <= -1
					p.mo.scale = FRACUNIT/8
				else
					p.mo.scale = FRACUNIT/4
					p.kartstuff[k_boostpower] = FRACUNIT+(FRACUNIT/2)
				end
			end
		end
	end,
})

// Items have 0 friction
ckAddPermEffect({
	name = "Friction",
	desc = "Items move uncontrollably!",
	startsound = sfx_ideya,
	mobjthinker = function(mo)
		if mo and mo.valid
			local itemmo = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_GIANTBANANA, MT_HORB}
			for i in pairs(itemmo)
				if mo.type == itemmo[i] 
					mo.friction = FRACUNIT
					P_Thrust(mo, mo.angle, 50*FRACUNIT)
				end
			end
		end
	end,
})

// Perm Accel
ckAddPermEffect({
	name = "Perm-Accel",
	desc = "Your accelerate button is broken!",
	startsound = sfx_ideya,
	synchnewjoiners = true,
	effect = function()
		ck.autoaccel = 10*TICRATE
	end,
})

// Perma Speed Shoes
ckAddPermEffect({
	name = "Speed Shoes",
	desc = "Speed Shoes all the time!",
	startsound = sfx_ideya,
	effect = function()
		for p in players.iterate
			if p.mo and p.mo.valid then p.kartstuff[k_sneakertimer] = 5*TICRATE end
		end
	end,
})

// Dorifto
ckAddPermEffect({
	name = "Kansei Dorifto",
	desc = "Kanseeei... Doriftoooo!",
	startsound = sfx_ideya,
	effect = function()
		for p in players.iterate			
			if p.kartstuff[k_driftcharge] > 2 then
				p.kartstuff[k_driftcharge] = 0 
				p.kartstuff[k_driftboost] = TICRATE
			end
		end
	end,
})

----------------------
-- Rare Perm Effects--
----------------------

// BananaRain
ckAddPermEffect({
	name = "BananaRain",
	desc = "Bananas from the sky?",
	rare = true,
	startsound = sfx_athun1,
	effect = function()
		local possiblePlayers = {}
		for p in players.iterate
			if (p and p.mo) and not p.spectator then table.insert(possiblePlayers, p.mo) end
		end
		if #possiblePlayers and not (leveltime%10)
			local bananas = {MT_BANANA, MT_BANANA, MT_BANANA, MT_BANANA, MT_BANANA, MT_BANANA, MT_BANANA, MT_BANANA, MT_BANANA, MT_GIANTBANANA}
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local banana = P_SpawnMobj(tmo.x+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.y+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, bananas[P_RandomRange(1, #bananas)])
			banana.fuse = 60*TICRATE
		end
	end,
})

// Bumpfuck but Permanent.
ckAddPermEffect({
	name = "Bonk Death",
	desc = "Avoid bonking!",
	startsound = sfx_athun1,
	rare = true,
	effect = function()
		for p in players.iterate
			if not p.spectator and (p and p.mo)
				if (p.mo.eflags & MFE_JUSTBOUNCEDWALL or p.kartstuff[k_justbumped] >= 1)
				and p.kartstuff[k_growshrinktimer] <= 0
				and p.playerstate == PST_LIVE
				and not p.exiting
				and not p.kartstuff[k_invincibilitytimer]
					K_SpawnMineExplosion(p.mo, p.mo.color)
					P_KillMobj(p.mo)
					S_StartSound(p.mo, sfx_s3k4e)
				end
			end
		end
	end,
})

// Meteor Rain
ckAddPermEffect({
	name = "Meteor Shower",
	desc = "Meteors fall from the sky!",
	startsound = sfx_athun1,
	rare = true,
	effect = function()
		local possiblePlayers = {}
		for p in players.iterate
			if (p and p.mo) and not p.spectator then table.insert(possiblePlayers, p.mo) end
		end
		if #possiblePlayers and not (leveltime%(2*TICRATE))
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local meteor = P_SpawnMobj(tmo.x+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.y+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_EXPLODINGMETEOR)
			meteor.scale = 2*FRACUNIT
		end
	end,
})

// Tornado Alley
ckAddPermEffect({
	name = "Tornado Alley",
	desc = "What's with all the tornados?",
	startsound = sfx_athun1,
	rare = true,
	effect = function()
		local possiblePlayers = {}
		for p in players.iterate
			if (p and p.mo) and not p.spectator then table.insert(possiblePlayers, p.mo) end
		end
		if #possiblePlayers and not (leveltime%(5*TICRATE))
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local tornado = P_SpawnMobj(tmo.x+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.y+P_RandomRange(-2500, 2500)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_TORNADO)
			tornado.scale = P_RandomRange(1, 4)*FRACUNIT
			tornado.fuse = 20*TICRATE
			tornado.nopull = true
		end
	end,
})

// Spring Floor
ckAddPermEffect({
	name = "Spring Floor",
	desc = "The floor is springy!",
	startsound = sfx_athun1,
	rare = true,
	effect = function()
		for p in players.iterate
			if P_IsObjectOnGround(p.mo)
				S_StartSound(p.mo, sfx_spring)
				P_SetObjectMomZ(p.mo, 25*FRACUNIT, true)
				P_Thrust(p.mo, p.mo.angle, 30*FRACUNIT)
			end
		end
	end,
})